diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java b/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
index 3d5f1de1e..bcbbac3d7 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
@@ -3,13 +3,14 @@ package net.minecraft.core.data.registry.recipe;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.crafting.recipe.TrommelRecipes;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.data.registry.recipe.entry.*;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 import java.util.*;
 
@@ -18,10 +19,10 @@ import java.util.*;
 public class RecipeRegistry extends Registry<RecipeNamespace> {
 
     public final RecipeNamespace MINECRAFT = new RecipeNamespace();
-    public final RecipeGroup<RecipeEntryCrafting<?,?>> WORKBENCH = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Block.workbench)));
-    public final RecipeGroup<RecipeEntryFurnace> FURNACE = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Block.furnaceStoneActive)));
-    public final RecipeGroup<RecipeEntryBlastFurnace> BLAST_FURNACE = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Block.furnaceBlastActive)));
-    public final RecipeGroup<RecipeEntryTrommel> TROMMEL = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Block.trommelActive)));
+    public final RecipeGroup<RecipeEntryCrafting<?,?>> WORKBENCH = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Blocks.WORKBENCH)));
+    public final RecipeGroup<RecipeEntryFurnace> FURNACE = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Blocks.FURNACE_STONE_ACTIVE)));
+    public final RecipeGroup<RecipeEntryBlastFurnace> BLAST_FURNACE = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Blocks.FURNACE_BLAST_ACTIVE)));
+    public final RecipeGroup<RecipeEntryTrommel> TROMMEL = new RecipeGroup<>(new RecipeSymbol(new ItemStack(Blocks.TROMMEL_ACTIVE)));
 
     private ArrayList<RecipeEntryCrafting<?,?>> recipeCache = null;
 
@@ -34,8 +35,31 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         MINECRAFT.register("blast_furnace",BLAST_FURNACE);
         MINECRAFT.register("trommel",TROMMEL);
         register("minecraft",MINECRAFT);
+        addProceduralRecipes();
+    }
+
+    public void addProceduralRecipes(){
         WORKBENCH.register("label",new RecipeEntryLabel());
         WORKBENCH.register("label_dye",new RecipeEntryLabelDye());
+
+        addCustomRecipe("minecraft:workbench/repair_chainmail_boots",       new RecipeEntryRepairable(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack(),        new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+        addCustomRecipe("minecraft:workbench/repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+        addCustomRecipe("minecraft:workbench/repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+        addCustomRecipe("minecraft:workbench/repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+
+        addCustomRecipe("minecraft:workbench/scrap_chainmail_boots",        new RecipeEntryScrap(Items.ARMOR_BOOTS_CHAINMAIL,       Items.CHAINLINK));
+        addCustomRecipe("minecraft:workbench/scrap_chainmail_leggings",     new RecipeEntryScrap(Items.ARMOR_LEGGINGS_CHAINMAIL,    Items.CHAINLINK));
+        addCustomRecipe("minecraft:workbench/scrap_chainmail_chestplate",   new RecipeEntryScrap(Items.ARMOR_CHESTPLATE_CHAINMAIL,  Items.CHAINLINK));
+        addCustomRecipe("minecraft:workbench/scrap_chainmail_helmet",       new RecipeEntryScrap(Items.ARMOR_HELMET_CHAINMAIL,      Items.CHAINLINK));
+
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_wood",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_WOOD,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_stone",    new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_STONE,    new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_iron",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_IRON,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_gold",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_GOLD,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_diamond",  new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_DIAMOND,  new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_steel",    new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_STEEL,    new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+
+        addCustomRecipe("minecraft:workbench/map_duplication", new RecipeEntryMapDuplication());
     }
 
     @Override
@@ -144,7 +168,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         return Collections.unmodifiableList(recipes);
     }
 
-    public ItemStack findMatchingRecipe(InventoryCrafting inventorycrafting)
+    public ItemStack findMatchingRecipe(CraftingContainer inventorycrafting)
     {
         for(int i = 0; i < getAllCraftingRecipes().size(); i++)
         {
@@ -158,7 +182,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         return null;
     }
 
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting)
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting)
     {
         for(int i = 0; i < getAllCraftingRecipes().size(); i++)
         {
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 2c616ad98..89b8f86c5 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -8,7 +8,9 @@ import com.google.gson.JsonParseException;
 import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 
 import java.lang.reflect.Type;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCloneMap.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCloneMap.java
index a5edf3914..822251e7c 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCloneMap.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCloneMap.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryCloneMap extends RecipeEntryCraftingDynamic {
 
 	@Override
-	public boolean matches(InventoryCrafting crafting) {
+	public boolean matches(CraftingContainer crafting) {
 		for(int x = 0; x < 3; x++) {
 			for(int y = 0; y < 3; y++) {
 				ItemStack stack = crafting.getItemStackAt(x, y);
@@ -18,11 +18,11 @@ public class RecipeEntryCloneMap extends RecipeEntryCraftingDynamic {
 				}
 				
 				if(x == 1 && y == 1) {
-					if(stack.itemID != Item.map.id) {
+					if(stack.itemID != Items.MAP.id) {
 						return false;
 					}
 				}else {
-					if(stack.itemID != Item.paper.id) {
+					if(stack.itemID != Items.PAPER.id) {
 						return false;
 					}
 				}
@@ -33,7 +33,7 @@ public class RecipeEntryCloneMap extends RecipeEntryCraftingDynamic {
 	}
 
 	@Override
-	public ItemStack getCraftingResult(InventoryCrafting crafting) {
+	public ItemStack getCraftingResult(CraftingContainer crafting) {
 		ItemStack output = crafting.getItemStackAt(1, 1).copy();
 		output.stackSize = 2;
 		return output;
@@ -50,12 +50,12 @@ public class RecipeEntryCloneMap extends RecipeEntryCraftingDynamic {
 	}
 
 	@Override
-	public ItemStack[] onCraftResult(InventoryCrafting crafting) {
-		for(int i=0; i < crafting.getSizeInventory(); i++) {
-			ItemStack stack = crafting.getStackInSlot(i);
+	public ItemStack[] onCraftResult(CraftingContainer crafting) {
+		for(int i = 0; i < crafting.getContainerSize(); i++) {
+			ItemStack stack = crafting.getItem(i);
 			stack.stackSize--;
 			if(stack.stackSize <= 0) {
-				crafting.setInventorySlotContents(i, null);
+				crafting.setItem(i, null);
 			}
 		}
 		return null;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
index cc4f5d3a9..3d9b181bd 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
@@ -3,7 +3,7 @@ package net.minecraft.core.data.registry.recipe.entry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void> {
 
@@ -23,7 +23,7 @@ public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void>
         return false;
     }
 
-    public abstract boolean matches(InventoryCrafting inventorycrafting);
+    public abstract boolean matches(CraftingContainer inventorycrafting);
 
     public boolean matchesQueryIgnoreExceptions(SearchQuery query){
         try {
@@ -35,9 +35,9 @@ public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void>
 
     public abstract boolean matchesQuery(SearchQuery query);
 
-    public abstract ItemStack getCraftingResult(InventoryCrafting inventorycrafting);
+    public abstract ItemStack getCraftingResult(CraftingContainer inventorycrafting);
 
     public abstract int getRecipeSize();
 
-    public abstract ItemStack[] onCraftResult(InventoryCrafting inventorycrafting);
+    public abstract ItemStack[] onCraftResult(CraftingContainer inventorycrafting);
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
index 44e456367..fa6c2000e 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
@@ -9,7 +9,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeCraftingShapedJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 import java.util.List;
 import java.util.Objects;
@@ -39,7 +39,7 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
     }
 
     @Override
-    public boolean matches(InventoryCrafting inventory) {
+    public boolean matches(CraftingContainer inventory) {
         for (int i = 0; i <= 3 - recipeWidth; i++) {
             for (int j = 0; j <= 3 - recipeHeight; j++) {
                 if (isRecipeMatching(inventory, i, j, true)) {
@@ -135,7 +135,7 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
         return false;
     }
 
-    private boolean isRecipeMatching(InventoryCrafting inventory, int i, int j, boolean flag) {
+    private boolean isRecipeMatching(CraftingContainer inventory, int i, int j, boolean flag) {
         for (int k = 0; k < 3; k++) {
             for (int l = 0; l < 3; l++) {
                 int i1 = k - i;
@@ -170,21 +170,21 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
     }
 
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting) {
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting) {
         return new ItemStack(getOutput().itemID, getOutput().stackSize, getOutput().getMetadata());
     }
 
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting) {
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
         ItemStack[] returnStack = new ItemStack[9];
-        for (int i = 0; i < inventorycrafting.getSizeInventory(); i++) {
-            ItemStack itemstack1 = inventorycrafting.getStackInSlot(i);
+        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
+            ItemStack itemstack1 = inventorycrafting.getItem(i);
             if (itemstack1 == null) {
                 continue;
             }
-            inventorycrafting.decrStackSize(i, 1);
+            inventorycrafting.removeItem(i, 1);
             if (!consumeContainerItem && itemstack1.getItem().hasContainerItem()) {
-                inventorycrafting.setInventorySlotContents(i, new ItemStack(itemstack1.getItem().getContainerItem()));
+                inventorycrafting.setItem(i, new ItemStack(itemstack1.getItem().getContainerItem()));
             }
         }
         return returnStack;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
index 6af3d71af..8547ed7cd 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
@@ -9,7 +9,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeCraftingShapelessJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -23,7 +23,7 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
     public RecipeEntryCraftingShapeless() {}
 
     @Override
-    public boolean matches(InventoryCrafting inventorycrafting)
+    public boolean matches(CraftingContainer inventorycrafting)
     {
         ArrayList<RecipeSymbol> arraylist = new ArrayList<>(getInput());
         int i = 0;
@@ -141,26 +141,26 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
     }
 
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
         ItemStack[] returnStack = new ItemStack[9];
-        for(int i = 0; i < inventorycrafting.getSizeInventory(); i++)
+        for(int i = 0; i < inventorycrafting.getContainerSize(); i++)
         {
-            ItemStack itemStack = inventorycrafting.getStackInSlot(i);
+            ItemStack itemStack = inventorycrafting.getItem(i);
             if(itemStack == null)
             {
                 continue;
             }
-            inventorycrafting.decrStackSize(i, 1);
+            inventorycrafting.removeItem(i, 1);
             if(itemStack.getItem().hasContainerItem())
             {
-                inventorycrafting.setInventorySlotContents(i, new ItemStack(itemStack.getItem().getContainerItem()));
+                inventorycrafting.setItem(i, new ItemStack(itemStack.getItem().getContainerItem()));
             }
         }
         return returnStack;
     }
 
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
     {
         return getOutput().copy();
     }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
index d1e6cdb42..996e881ca 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
@@ -1,20 +1,9 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
-import net.minecraft.core.data.registry.recipe.RecipeGroup;
-import net.minecraft.core.data.registry.recipe.RecipeNamespace;
-import net.minecraft.core.data.registry.recipe.RecipeSymbol;
-import net.minecraft.core.data.registry.recipe.adapter.RecipeCraftingShapelessJsonAdapter;
-import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
-
-import java.util.ArrayList;
-import java.util.List;
-import java.util.Objects;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
     public RecipeEntryCraftingWithTool(ItemStack inItemStack, Item toolToUse, ItemStack output) {
@@ -27,7 +16,7 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(InventoryCrafting inventorycrafting) {
+    public boolean matches(CraftingContainer inventorycrafting) {
         boolean toolMatch = false;
         boolean itemMatch = false;
 
@@ -55,12 +44,12 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack getCraftingResult(InventoryCrafting inventorycrafting) {
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting) {
         return new ItemStack(output.itemID, output.stackSize, output.getMetadata());
     }
 
     @Override
-    public ItemStack[] onCraftResult(InventoryCrafting inventorycrafting) {
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
         ItemStack[] returnStack = new ItemStack[9];
         for (int x = 0; x < 3; x++) {
             for (int y = 0; y < 3; y++) {
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
index 01ee12009..70a0770a9 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
     @Override
-    public ItemStack getCraftingResult(final InventoryCrafting inventorycrafting) {
+    public ItemStack getCraftingResult(final CraftingContainer inventorycrafting) {
         ItemStack labelStack = null;
         ItemStack otherItem = null;
 
@@ -17,7 +17,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID == Item.label.id && labelStack == null) {
+                if(stack.itemID == Items.LABEL.id && labelStack == null) {
                     labelStack = stack;
                 } else if(otherItem == null) {
                     otherItem = stack;
@@ -48,7 +48,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(final InventoryCrafting crafting) {
+    public boolean matches(final CraftingContainer crafting) {
         ItemStack labelStack = null;
         ItemStack otherStack = null;
 
@@ -58,7 +58,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID == Item.label.id) {
+                if(stack.itemID == Items.LABEL.id) {
                     if(labelStack != null || !stack.hasCustomName()) {
                         return false;
                     }
@@ -76,7 +76,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
             return false;
         }
 
-        if(otherStack.itemID == Item.dye.id) {
+        if(otherStack.itemID == Items.DYE.id) {
             // If the label is not already colored, it should be recolored by RecipeLabelDye
             if(!labelStack.hasCustomColor()) {
                 return false;
@@ -111,7 +111,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack[] onCraftResult(final InventoryCrafting crafting) {
+    public ItemStack[] onCraftResult(final CraftingContainer crafting) {
         final ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
@@ -119,7 +119,7 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID != Item.label.id) {
+                if(stack.itemID != Items.LABEL.id) {
                     stack.stackSize--;
                     if(stack.stackSize <= 0) {
                         crafting.setSlotContentsAt(x, y, null);
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
index a8eec3368..17c5b0331 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryCrafting;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
 
 public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
     @Override
-    public ItemStack getCraftingResult(final InventoryCrafting inventorycrafting) {
+    public ItemStack getCraftingResult(final CraftingContainer inventorycrafting) {
         ItemStack labelStack = null;
         ItemStack dyeStack = null;
 
@@ -17,9 +17,9 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID == Item.label.id && labelStack == null) {
+                if(stack.itemID == Items.LABEL.id && labelStack == null) {
                     labelStack = stack;
-                } else if(stack.itemID == Item.dye.id && dyeStack == null) {
+                } else if(stack.itemID == Items.DYE.id && dyeStack == null) {
                     dyeStack = stack;
                 }
                 if(labelStack != null && dyeStack != null) {
@@ -45,7 +45,7 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public boolean matches(final InventoryCrafting crafting) {
+    public boolean matches(final CraftingContainer crafting) {
         ItemStack labelStack = null;
         ItemStack dyeStack = null;
 
@@ -55,12 +55,12 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID == Item.label.id) {
+                if(stack.itemID == Items.LABEL.id) {
                     if(labelStack != null) {
                         return false;
                     }
                     labelStack = stack;
-                } else if(stack.itemID == Item.dye.id){
+                } else if(stack.itemID == Items.DYE.id){
                     if(dyeStack != null) {
                         return false;
                     }
@@ -88,7 +88,7 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public ItemStack[] onCraftResult(final InventoryCrafting crafting) {
+    public ItemStack[] onCraftResult(final CraftingContainer crafting) {
         final ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
new file mode 100644
index 000000000..314f3fbd8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
@@ -0,0 +1,83 @@
+package net.minecraft.core.data.registry.recipe.entry;
+
+import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.MapItem;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
+
+public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
+
+    @Override
+    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    {
+        ItemStack map = null;
+        int paperAmount = 0;
+        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
+            ItemStack s = inventorycrafting.getItem(i);
+            if (s != null)
+            {
+                Item item = s.getItem();
+                if (item == Items.MAP) {
+                    map = s;
+                } else if (item == Items.PAPER) {
+                    paperAmount++;
+                }
+            }
+        }
+        assert map != null;
+        ItemStack output = map.copy();
+        output.stackSize += paperAmount;
+        return output;
+    }
+
+    @Override
+    public int getRecipeSize() {
+        return 2;
+    }
+
+    @Override
+    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
+        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
+            inventorycrafting.setItem(i, null);
+        }
+        return new ItemStack[0];
+    }
+
+    @Override
+    public boolean matches(CraftingContainer inventorycrafting) {
+        ItemStack mapStack = null;
+        boolean hasPaper = false;
+
+        for(int x = 0; x < 3; x++) {
+            for(int y = 0; y < 3; y++) {
+                final ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                if(stack == null) {
+                    continue;
+                }
+                if(stack.itemID == Items.MAP.id) {
+                    if(mapStack != null) {
+                        return false;
+                    }
+                    mapStack = stack;
+                } else if(stack.itemID == Items.PAPER.id){
+                    hasPaper = true;
+                }else {
+                    return false;
+                }
+            }
+        }
+
+        if (mapStack == null) return  false;
+        if (!MapItem.hasInitialized(mapStack)) return false;
+        if (!hasPaper) return false;
+
+        return true;
+    }
+
+    @Override
+    public boolean matchesQuery(SearchQuery query) {
+        return false;
+    }
+}
